//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include <dbt.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormCdChange *FormCdChange;
//---------------------------------------------------------------------------
char FirstDriveFromMask(ULONG unitmask)
{
    char i;
	for(i = 0; i < 26; ++i){
		if (unitmask & 0x1)
            break;
		unitmask = unitmask >> 1;
	}
    return (i + 'A');
}
//---------------------------------------------------------------------------
__fastcall TFormCdChange::TFormCdChange(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormCdChange::OnDeviceChange(TMessage& Msg)
{
    AnsiString strMsg;
	PDEV_BROADCAST_HDR lpdb = (PDEV_BROADCAST_HDR) Msg.LParam;

	switch(Msg.WParam){
	case DBT_DEVICEARRIVAL:
		if (lpdb->dbch_devicetype == DBT_DEVTYP_VOLUME)
        {	// Logical volume
			PDEV_BROADCAST_VOLUME lpdbv = (PDEV_BROADCAST_VOLUME)lpdb;
			if (lpdbv->dbcv_flags & DBTF_MEDIA)
            {
                strMsg.sprintf("Drive %c arrived", FirstDriveFromMask(lpdbv->dbcv_unitmask));
                // MessageDlg(strMsg, mtInformation, TMsgDlgButtons() << mbOK, 0);
                EditEventStatus->Text = strMsg;
				return;
			}
		}
		break;
	case DBT_DEVICEREMOVECOMPLETE:
		if (lpdb->dbch_devicetype == DBT_DEVTYP_VOLUME)
        {	// Logical volume
			PDEV_BROADCAST_VOLUME lpdbv = (PDEV_BROADCAST_VOLUME)lpdb;
			if (lpdbv -> dbcv_flags & DBTF_MEDIA)
            {
                strMsg.sprintf("Drive %c removed", FirstDriveFromMask(lpdbv->dbcv_unitmask));
                // MessageDlg(strMsg, mtInformation, TMsgDlgButtons() << mbOK, 0);
                EditEventStatus->Text = strMsg;
				return;
			}
		}
		break;
	}

    TForm::Dispatch(&Msg);
}
